(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common/http'), require('@angular/common'), require('powerbi-client')) :
    typeof define === 'function' && define.amd ? define('angular-powerbi-report', ['exports', '@angular/core', '@angular/common/http', '@angular/common', 'powerbi-client'], factory) :
    (global = global || self, factory(global['angular-powerbi-report'] = {}, global.ng.core, global.ng.common.http, global.ng.common, global['powerbi-client']));
}(this, (function (exports, core, http, common, powerbiClient) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/powerbi-report.service.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var PowerBiReportService = /** @class */ (function () {
        function PowerBiReportService(http) {
            this.http = http;
        }
        /**
         * @param {?} url
         * @return {?}
         */
        PowerBiReportService.prototype.getPowerBiReportToken = /**
         * @param {?} url
         * @return {?}
         */
        function (url) {
            return this.http.get(url);
        };
        PowerBiReportService.decorators = [
            { type: core.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */
        PowerBiReportService.ctorParameters = function () { return [
            { type: http.HttpClient }
        ]; };
        /** @nocollapse */ PowerBiReportService.ngInjectableDef = core.ɵɵdefineInjectable({ factory: function PowerBiReportService_Factory() { return new PowerBiReportService(core.ɵɵinject(http.HttpClient)); }, token: PowerBiReportService, providedIn: "root" });
        return PowerBiReportService;
    }());
    if (false) {
        /**
         * @type {?}
         * @private
         */
        PowerBiReportService.prototype.http;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/config.model.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ReportConfig = /** @class */ (function () {
        function ReportConfig() {
        }
        return ReportConfig;
    }());
    if (false) {
        /** @type {?} */
        ReportConfig.prototype.powerbiTokenUrl;
        /** @type {?} */
        ReportConfig.prototype.workspaceId;
        /** @type {?} */
        ReportConfig.prototype.reportId;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/report/report.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ReportComponent = /** @class */ (function () {
        function ReportComponent(dataService) {
            this.dataService = dataService;
        }
        /**
         * @return {?}
         */
        ReportComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            this.screenHeight = (window.screen.height);
            this.getToken();
        };
        /**
         * @return {?}
         */
        ReportComponent.prototype.getToken = /**
         * @return {?}
         */
        function () {
            var _this = this;
            /** @type {?} */
            var url = this.getURL();
            this.dataService.getPowerBiReportToken(url).subscribe((/**
             * @param {?} data
             * @return {?}
             */
            function (data) {
                /** @type {?} */
                var reportid = data.Id;
                /** @type {?} */
                var embedurl = data.EmbedUrl;
                /** @type {?} */
                var accessToken = data.EmbedToken.token;
                _this.showReport(reportid, embedurl, accessToken);
            }));
        };
        /**
         * @return {?}
         */
        ReportComponent.prototype.getURL = /**
         * @return {?}
         */
        function () {
            return this.reportConfig.powerbiTokenUrl
                + '&workspaceid='
                + this.reportConfig.workspaceId
                + '&reportid='
                + this.reportConfig.reportId;
        };
        /**
         * @param {?} reportid
         * @param {?} reporturl
         * @param {?} accessToken
         * @return {?}
         */
        ReportComponent.prototype.showReport = /**
         * @param {?} reportid
         * @param {?} reporturl
         * @param {?} accessToken
         * @return {?}
         */
        function (reportid, reporturl, accessToken) {
            var _this = this;
            /** @type {?} */
            var models$1 = powerbiClient.models;
            /** @type {?} */
            var config = {
                type: 'report',
                tokenType: models$1.TokenType.Embed,
                accessToken: accessToken,
                embedUrl: reporturl,
                id: reportid,
                permissions: models$1.Permissions.All,
                settings: {}
            };
            /** @type {?} */
            var reportContainer = this.reportContainer.nativeElement;
            /** @type {?} */
            var powerbi = new powerbiClient.service.Service(powerbiClient.factories.hpmFactory, powerbiClient.factories.wpmpFactory, powerbiClient.factories.routerFactory);
            /** @type {?} */
            var report = powerbi.embed(reportContainer, config);
            report.off('loaded');
            report.on('loaded', (/**
             * @return {?}
             */
            function () {
                console.log('Loaded');
            }));
            report.on('error', (/**
             * @return {?}
             */
            function () {
                _this.getToken();
            }));
        };
        ReportComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'pbi-report',
                        template: "<div class=\"report-container\" [ngStyle]=\"reportStyle\" #reportContainer></div>",
                        styles: [""]
                    }] }
        ];
        /** @nocollapse */
        ReportComponent.ctorParameters = function () { return [
            { type: PowerBiReportService }
        ]; };
        ReportComponent.propDecorators = {
            reportConfig: [{ type: core.Input }],
            reportStyle: [{ type: core.Input }],
            reportContainer: [{ type: core.ViewChild, args: ['reportContainer', { static: false },] }]
        };
        return ReportComponent;
    }());
    if (false) {
        /** @type {?} */
        ReportComponent.prototype.reportConfig;
        /** @type {?} */
        ReportComponent.prototype.reportStyle;
        /** @type {?} */
        ReportComponent.prototype.powerbihtml;
        /** @type {?} */
        ReportComponent.prototype.screenHeight;
        /** @type {?} */
        ReportComponent.prototype.reportContainer;
        /** @type {?} */
        ReportComponent.prototype.reportType;
        /**
         * @type {?}
         * @private
         */
        ReportComponent.prototype.dataService;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/powerbi-report.module.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var PowerBiReportModule = /** @class */ (function () {
        function PowerBiReportModule() {
        }
        PowerBiReportModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [ReportComponent],
                        imports: [
                            common.CommonModule
                        ],
                        exports: [ReportComponent]
                    },] }
        ];
        return PowerBiReportModule;
    }());

    exports.PowerBiReportModule = PowerBiReportModule;
    exports.PowerBiReportService = PowerBiReportService;
    exports.ReportComponent = ReportComponent;
    exports.ReportConfig = ReportConfig;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=angular-powerbi-report.umd.js.map
