import { Injectable, ɵɵdefineInjectable, ɵɵinject, Component, Input, ViewChild, NgModule } from '@angular/core';
import { HttpClient } from '@angular/common/http';
import { CommonModule } from '@angular/common';
import { models, service, factories } from 'powerbi-client';

/**
 * @fileoverview added by tsickle
 * Generated from: lib/powerbi-report.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class PowerBiReportService {
    /**
     * @param {?} http
     */
    constructor(http) {
        this.http = http;
    }
    /**
     * @param {?} url
     * @return {?}
     */
    getPowerBiReportToken(url) {
        return this.http.get(url);
    }
}
PowerBiReportService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
PowerBiReportService.ctorParameters = () => [
    { type: HttpClient }
];
/** @nocollapse */ PowerBiReportService.ngInjectableDef = ɵɵdefineInjectable({ factory: function PowerBiReportService_Factory() { return new PowerBiReportService(ɵɵinject(HttpClient)); }, token: PowerBiReportService, providedIn: "root" });
if (false) {
    /**
     * @type {?}
     * @private
     */
    PowerBiReportService.prototype.http;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/config.model.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class ReportConfig {
}
if (false) {
    /** @type {?} */
    ReportConfig.prototype.powerbiTokenUrl;
    /** @type {?} */
    ReportConfig.prototype.workspaceId;
    /** @type {?} */
    ReportConfig.prototype.reportId;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/report/report.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class ReportComponent {
    /**
     * @param {?} dataService
     */
    constructor(dataService) {
        this.dataService = dataService;
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.screenHeight = (window.screen.height);
        this.getToken();
    }
    /**
     * @return {?}
     */
    getToken() {
        /** @type {?} */
        const url = this.getURL();
        this.dataService.getPowerBiReportToken(url).subscribe((/**
         * @param {?} data
         * @return {?}
         */
        (data) => {
            /** @type {?} */
            const reportid = data.Id;
            /** @type {?} */
            const embedurl = data.EmbedUrl;
            /** @type {?} */
            const accessToken = data.EmbedToken.token;
            this.showReport(reportid, embedurl, accessToken);
        }));
    }
    /**
     * @return {?}
     */
    getURL() {
        return this.reportConfig.powerbiTokenUrl
            + '&workspaceid='
            + this.reportConfig.workspaceId
            + '&reportid='
            + this.reportConfig.reportId;
    }
    /**
     * @param {?} reportid
     * @param {?} reporturl
     * @param {?} accessToken
     * @return {?}
     */
    showReport(reportid, reporturl, accessToken) {
        /** @type {?} */
        const models$1 = models;
        /** @type {?} */
        const config = {
            type: 'report',
            tokenType: models$1.TokenType.Embed,
            accessToken,
            embedUrl: reporturl,
            id: reportid,
            permissions: models$1.Permissions.All,
            settings: {}
        };
        /** @type {?} */
        const reportContainer = this.reportContainer.nativeElement;
        /** @type {?} */
        const powerbi = new service.Service(factories.hpmFactory, factories.wpmpFactory, factories.routerFactory);
        /** @type {?} */
        const report = powerbi.embed(reportContainer, config);
        report.off('loaded');
        report.on('loaded', (/**
         * @return {?}
         */
        () => {
            console.log('Loaded');
        }));
        report.on('error', (/**
         * @return {?}
         */
        () => {
            this.getToken();
        }));
    }
}
ReportComponent.decorators = [
    { type: Component, args: [{
                selector: 'pbi-report',
                template: "<div class=\"report-container\" [ngStyle]=\"reportStyle\" #reportContainer></div>",
                styles: [""]
            }] }
];
/** @nocollapse */
ReportComponent.ctorParameters = () => [
    { type: PowerBiReportService }
];
ReportComponent.propDecorators = {
    reportConfig: [{ type: Input }],
    reportStyle: [{ type: Input }],
    reportContainer: [{ type: ViewChild, args: ['reportContainer', { static: false },] }]
};
if (false) {
    /** @type {?} */
    ReportComponent.prototype.reportConfig;
    /** @type {?} */
    ReportComponent.prototype.reportStyle;
    /** @type {?} */
    ReportComponent.prototype.powerbihtml;
    /** @type {?} */
    ReportComponent.prototype.screenHeight;
    /** @type {?} */
    ReportComponent.prototype.reportContainer;
    /** @type {?} */
    ReportComponent.prototype.reportType;
    /**
     * @type {?}
     * @private
     */
    ReportComponent.prototype.dataService;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/powerbi-report.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class PowerBiReportModule {
}
PowerBiReportModule.decorators = [
    { type: NgModule, args: [{
                declarations: [ReportComponent],
                imports: [
                    CommonModule
                ],
                exports: [ReportComponent]
            },] }
];

/**
 * @fileoverview added by tsickle
 * Generated from: public-api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: angular-powerbi-report.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { PowerBiReportModule, PowerBiReportService, ReportComponent, ReportConfig };
//# sourceMappingURL=angular-powerbi-report.js.map
