import { Injectable, ɵɵdefineInjectable, ɵɵinject, Component, Input, ViewChild, NgModule } from '@angular/core';
import { HttpClient } from '@angular/common/http';
import { CommonModule } from '@angular/common';
import { models, service, factories } from 'powerbi-client';

/**
 * @fileoverview added by tsickle
 * Generated from: lib/powerbi-report.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var PowerBiReportService = /** @class */ (function () {
    function PowerBiReportService(http) {
        this.http = http;
    }
    /**
     * @param {?} url
     * @return {?}
     */
    PowerBiReportService.prototype.getPowerBiReportToken = /**
     * @param {?} url
     * @return {?}
     */
    function (url) {
        return this.http.get(url);
    };
    PowerBiReportService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    PowerBiReportService.ctorParameters = function () { return [
        { type: HttpClient }
    ]; };
    /** @nocollapse */ PowerBiReportService.ngInjectableDef = ɵɵdefineInjectable({ factory: function PowerBiReportService_Factory() { return new PowerBiReportService(ɵɵinject(HttpClient)); }, token: PowerBiReportService, providedIn: "root" });
    return PowerBiReportService;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    PowerBiReportService.prototype.http;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/config.model.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ReportConfig = /** @class */ (function () {
    function ReportConfig() {
    }
    return ReportConfig;
}());
if (false) {
    /** @type {?} */
    ReportConfig.prototype.powerbiTokenUrl;
    /** @type {?} */
    ReportConfig.prototype.workspaceId;
    /** @type {?} */
    ReportConfig.prototype.reportId;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/report/report.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ReportComponent = /** @class */ (function () {
    function ReportComponent(dataService) {
        this.dataService = dataService;
    }
    /**
     * @return {?}
     */
    ReportComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        this.screenHeight = (window.screen.height);
        this.getToken();
    };
    /**
     * @return {?}
     */
    ReportComponent.prototype.getToken = /**
     * @return {?}
     */
    function () {
        var _this = this;
        /** @type {?} */
        var url = this.getURL();
        this.dataService.getPowerBiReportToken(url).subscribe((/**
         * @param {?} data
         * @return {?}
         */
        function (data) {
            /** @type {?} */
            var reportid = data.Id;
            /** @type {?} */
            var embedurl = data.EmbedUrl;
            /** @type {?} */
            var accessToken = data.EmbedToken.token;
            _this.showReport(reportid, embedurl, accessToken);
        }));
    };
    /**
     * @return {?}
     */
    ReportComponent.prototype.getURL = /**
     * @return {?}
     */
    function () {
        return this.reportConfig.powerbiTokenUrl
            + '&workspaceid='
            + this.reportConfig.workspaceId
            + '&reportid='
            + this.reportConfig.reportId;
    };
    /**
     * @param {?} reportid
     * @param {?} reporturl
     * @param {?} accessToken
     * @return {?}
     */
    ReportComponent.prototype.showReport = /**
     * @param {?} reportid
     * @param {?} reporturl
     * @param {?} accessToken
     * @return {?}
     */
    function (reportid, reporturl, accessToken) {
        var _this = this;
        /** @type {?} */
        var models$1 = models;
        /** @type {?} */
        var config = {
            type: 'report',
            tokenType: models$1.TokenType.Embed,
            accessToken: accessToken,
            embedUrl: reporturl,
            id: reportid,
            permissions: models$1.Permissions.All,
            settings: {}
        };
        /** @type {?} */
        var reportContainer = this.reportContainer.nativeElement;
        /** @type {?} */
        var powerbi = new service.Service(factories.hpmFactory, factories.wpmpFactory, factories.routerFactory);
        /** @type {?} */
        var report = powerbi.embed(reportContainer, config);
        report.off('loaded');
        report.on('loaded', (/**
         * @return {?}
         */
        function () {
            console.log('Loaded');
        }));
        report.on('error', (/**
         * @return {?}
         */
        function () {
            _this.getToken();
        }));
    };
    ReportComponent.decorators = [
        { type: Component, args: [{
                    selector: 'pbi-report',
                    template: "<div class=\"report-container\" [ngStyle]=\"reportStyle\" #reportContainer></div>",
                    styles: [""]
                }] }
    ];
    /** @nocollapse */
    ReportComponent.ctorParameters = function () { return [
        { type: PowerBiReportService }
    ]; };
    ReportComponent.propDecorators = {
        reportConfig: [{ type: Input }],
        reportStyle: [{ type: Input }],
        reportContainer: [{ type: ViewChild, args: ['reportContainer', { static: false },] }]
    };
    return ReportComponent;
}());
if (false) {
    /** @type {?} */
    ReportComponent.prototype.reportConfig;
    /** @type {?} */
    ReportComponent.prototype.reportStyle;
    /** @type {?} */
    ReportComponent.prototype.powerbihtml;
    /** @type {?} */
    ReportComponent.prototype.screenHeight;
    /** @type {?} */
    ReportComponent.prototype.reportContainer;
    /** @type {?} */
    ReportComponent.prototype.reportType;
    /**
     * @type {?}
     * @private
     */
    ReportComponent.prototype.dataService;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/powerbi-report.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var PowerBiReportModule = /** @class */ (function () {
    function PowerBiReportModule() {
    }
    PowerBiReportModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [ReportComponent],
                    imports: [
                        CommonModule
                    ],
                    exports: [ReportComponent]
                },] }
    ];
    return PowerBiReportModule;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: public-api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: angular-powerbi-report.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { PowerBiReportModule, PowerBiReportService, ReportComponent, ReportConfig };
//# sourceMappingURL=angular-powerbi-report.js.map
